﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MVVM_sample
{
    /// <summary>
    /// 会員情報のリストクラス
    /// </summary>
    class MemberList
    {
        /// <summary>
        /// 会員情報のリスト
        /// </summary>
        private ObservableCollection<MemberInfo> m_MemberInfoList;
        public ObservableCollection<MemberInfo> MemberInfoList { get { return m_MemberInfoList; } }

        /// <summary>
        /// コンストラクタ
        /// </summary>
        public MemberList()
        {
            m_MemberInfoList = new ObservableCollection<MemberInfo>();
        }

        /// <summary>
        /// 会員追加
        /// </summary>
        /// <param name="newVal"></param>
        public void Add(MemberInfo newVal)
        {
            m_MemberInfoList.Add(newVal);
        }

        /// <summary>
        /// 会員削除
        /// </summary>
        /// <param name="val"></param>
        public void Remove(MemberInfo val)
        {
            m_MemberInfoList.Remove(val);
        }

        /// <summary>
        /// 会員の年齢取得
        /// </summary>
        /// <param name="keyName"></param>
        /// <returns></returns>
        public int GetAge(string keyName)
        {
            int ret = -1;

            MemberInfo tgt = m_MemberInfoList.First(delegate(MemberInfo arg)
            {
                return arg.Name == keyName;
            });
            if (tgt != null)
            {
                ret = tgt.Age;
            }

            return ret;
        }

        /// <summary>
        /// 会員の性別取得
        /// </summary>
        /// <param name="keyName"></param>
        /// <returns></returns>
        public Sex GetSex(string keyName)
        {
            Sex ret = Sex.FEMALE;

            MemberInfo tgt = m_MemberInfoList.First(delegate(MemberInfo arg)
            {
                return arg.Name == keyName;
            });
            if (tgt != null)
            {
                ret = tgt.Sex;
            }

            return ret;
        }
    }

    /// <summary>
    /// 会員情報クラス
    /// </summary>
    class MemberInfo
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public Sex Sex{ get; set; }
    }
}
